package plugins

import "strings"

/*
This map is based by https://github.com/melborne/emot/blob/master/lib/emot/map.rb
=================================================================================

Copyright (c) 2014 kyoendo

MIT License

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
var name2codes = map[string][]rune{
	"+1":                              []rune{0x1F44D},
	"-1":                              []rune{0x1F44E},
	"-100":                            []rune{0x1F4AF},
	"-1234":                           []rune{0x1F522},
	"8ball":                           []rune{0x1F3B1},
	"a":                               []rune{0x1F170},
	"ab":                              []rune{0x1F18E},
	"abc":                             []rune{0x1F524},
	"abcd":                            []rune{0x1F521},
	"accept":                          []rune{0x1F251},
	"aerial_tramway":                  []rune{0x1F6A1},
	"airplane":                        []rune{0x2708, 0xFE0F},
	"alarm_clock":                     []rune{0x23F0},
	"alien":                           []rune{0x1F47D},
	"ambulance":                       []rune{0x1F691},
	"anchor":                          []rune{0x2693, 0xFE0F},
	"angel":                           []rune{0x1F47C},
	"anger":                           []rune{0x1F4A2},
	"angry":                           []rune{0x1F620},
	"anguished":                       []rune{0x1F627},
	"ant":                             []rune{0x1F41C},
	"apple":                           []rune{0x1F34E},
	"aquarius":                        []rune{0x2652, 0xFE0F},
	"aries":                           []rune{0x2648, 0xFE0F},
	"arrow_backward":                  []rune{0x25C0, 0xFE0F},
	"arrow_double_down":               []rune{0x23EC},
	"arrow_double_up":                 []rune{0x23EB},
	"arrow_down":                      []rune{0x2B07, 0xFE0F},
	"arrow_down_small":                []rune{0x1F53D},
	"arrow_forward":                   []rune{0x25B6, 0xFE0F},
	"arrow_heading_down":              []rune{0x2935, 0xFE0F},
	"arrow_heading_up":                []rune{0x2934, 0xFE0F},
	"arrow_left":                      []rune{0x2B05, 0xFE0F},
	"arrow_lower_left":                []rune{0x2199, 0xFE0F},
	"arrow_lower_right":               []rune{0x2198, 0xFE0F},
	"arrow_right":                     []rune{0x27A1, 0xFE0F},
	"arrow_right_hook":                []rune{0x21AA, 0xFE0F},
	"arrow_up":                        []rune{0x2B06, 0xFE0F},
	"arrow_up_down":                   []rune{0x2195, 0xFE0F},
	"arrow_up_small":                  []rune{0x1F53C},
	"arrow_upper_left":                []rune{0x2196, 0xFE0F},
	"arrow_upper_right":               []rune{0x2197, 0xFE0F},
	"arrows_clockwise":                []rune{0x1F503},
	"arrows_counterclockwise":         []rune{0x1F504},
	"art":                             []rune{0x1F3A8},
	"articulated_lorry":               []rune{0x1F69B},
	"astonished":                      []rune{0x1F632},
	"athletic_shoe":                   []rune{0x1F45F},
	"atm":                             []rune{0x1F3E7},
	"b":                               []rune{0x1F171},
	"baby":                            []rune{0x1F476},
	"baby_bottle":                     []rune{0x1F37C},
	"baby_chick":                      []rune{0x1F424},
	"baby_symbol":                     []rune{0x1F6BC},
	"back":                            []rune{0x1F519},
	"baggage_claim":                   []rune{0x1F6C4},
	"balloon":                         []rune{0x1F388},
	"ballot_box_with_check":           []rune{0x2611, 0xFE0F},
	"bamboo":                          []rune{0x1F38D},
	"banana":                          []rune{0x1F34C},
	"bangbang":                        []rune{0x203C, 0xFE0F},
	"bank":                            []rune{0x1F3E6},
	"bar_chart":                       []rune{0x1F4CA},
	"barber":                          []rune{0x1F488},
	"baseball":                        []rune{0x26BE, 0xFE0F},
	"basketball":                      []rune{0x1F3C0},
	"bath":                            []rune{0x1F6C0},
	"bathtub":                         []rune{0x1F6C1},
	"battery":                         []rune{0x1F50B},
	"bear":                            []rune{0x1F43B},
	"bee":                             []rune{0x1F41D},
	"beer":                            []rune{0x1F37A},
	"beers":                           []rune{0x1F37B},
	"beetle":                          []rune{0x1F41E},
	"beginner":                        []rune{0x1F530},
	"bell":                            []rune{0x1F514},
	"bento":                           []rune{0x1F371},
	"bicyclist":                       []rune{0x1F6B4},
	"bike":                            []rune{0x1F6B2},
	"bikini":                          []rune{0x1F459},
	"bird":                            []rune{0x1F426},
	"birthday":                        []rune{0x1F382},
	"black_circle":                    []rune{0x26AB, 0xFE0F},
	"black_joker":                     []rune{0x1F0CF},
	"black_large_square":              []rune{0x2B1B, 0xFE0F},
	"black_medium_small_square":       []rune{0x25FE, 0xFE0F},
	"black_medium_square":             []rune{0x25FC, 0xFE0F},
	"black_nib":                       []rune{0x2712, 0xFE0F},
	"black_small_square":              []rune{0x25AA, 0xFE0F},
	"black_square_button":             []rune{0x1F532},
	"blossom":                         []rune{0x1F33C},
	"blowfish":                        []rune{0x1F421},
	"blue_book":                       []rune{0x1F4D8},
	"blue_car":                        []rune{0x1F699},
	"blue_heart":                      []rune{0x1F499},
	"blush":                           []rune{0x1F60A},
	"boar":                            []rune{0x1F417},
	"boat":                            []rune{0x26F5, 0xFE0F},
	"bomb":                            []rune{0x1F4A3},
	"book":                            []rune{0x1F4D6},
	"bookmark":                        []rune{0x1F516},
	"bookmark_tabs":                   []rune{0x1F4D1},
	"books":                           []rune{0x1F4DA},
	"boom":                            []rune{0x1F4A5},
	"boot":                            []rune{0x1F462},
	"bouquet":                         []rune{0x1F490},
	"bow":                             []rune{0x1F647},
	"bowling":                         []rune{0x1F3B3},
	"boy":                             []rune{0x1F466},
	"bread":                           []rune{0x1F35E},
	"bride_with_veil":                 []rune{0x1F470},
	"bridge_at_night":                 []rune{0x1F309},
	"briefcase":                       []rune{0x1F4BC},
	"broken_heart":                    []rune{0x1F494},
	"bug":                             []rune{0x1F41B},
	"bulb":                            []rune{0x1F4A1},
	"bullettrain_front":               []rune{0x1F685},
	"bullettrain_side":                []rune{0x1F684},
	"bus":                             []rune{0x1F68C},
	"busstop":                         []rune{0x1F68F},
	"bust_in_silhouette":              []rune{0x1F464},
	"busts_in_silhouette":             []rune{0x1F465},
	"cactus":                          []rune{0x1F335},
	"cake":                            []rune{0x1F370},
	"calendar":                        []rune{0x1F4C6},
	"calling":                         []rune{0x1F4F2},
	"camel":                           []rune{0x1F42B},
	"camera":                          []rune{0x1F4F7},
	"cancer":                          []rune{0x264B, 0xFE0F},
	"candy":                           []rune{0x1F36C},
	"capital_abcd":                    []rune{0x1F520},
	"capricorn":                       []rune{0x2651, 0xFE0F},
	"car":                             []rune{0x1F697},
	"card_index":                      []rune{0x1F4C7},
	"carousel_horse":                  []rune{0x1F3A0},
	"cat":                             []rune{0x1F431},
	"cat2":                            []rune{0x1F408},
	"cd":                              []rune{0x1F4BF},
	"chart":                           []rune{0x1F4B9},
	"chart_with_downwards_trend":      []rune{0x1F4C9},
	"chart_with_upwards_trend":        []rune{0x1F4C8},
	"checkered_flag":                  []rune{0x1F3C1},
	"cherries":                        []rune{0x1F352},
	"cherry_blossom":                  []rune{0x1F338},
	"chestnut":                        []rune{0x1F330},
	"chicken":                         []rune{0x1F414},
	"children_crossing":               []rune{0x1F6B8},
	"chocolate_bar":                   []rune{0x1F36B},
	"christmas_tree":                  []rune{0x1F384},
	"church":                          []rune{0x26EA, 0xFE0F},
	"cinema":                          []rune{0x1F3A6},
	"circus_tent":                     []rune{0x1F3AA},
	"city_sunrise":                    []rune{0x1F307},
	"city_sunset":                     []rune{0x1F306},
	"cl":                              []rune{0x1F191},
	"clap":                            []rune{0x1F44F},
	"clapper":                         []rune{0x1F3AC},
	"clipboard":                       []rune{0x1F4CB},
	"clock1":                          []rune{0x1F550},
	"clock10":                         []rune{0x1F559},
	"clock1030":                       []rune{0x1F565},
	"clock11":                         []rune{0x1F55A},
	"clock1130":                       []rune{0x1F566},
	"clock12":                         []rune{0x1F55B},
	"clock1230":                       []rune{0x1F567},
	"clock130":                        []rune{0x1F55C},
	"clock2":                          []rune{0x1F551},
	"clock230":                        []rune{0x1F55D},
	"clock3":                          []rune{0x1F552},
	"clock330":                        []rune{0x1F55E},
	"clock4":                          []rune{0x1F553},
	"clock430":                        []rune{0x1F55F},
	"clock5":                          []rune{0x1F554},
	"clock530":                        []rune{0x1F560},
	"clock6":                          []rune{0x1F555},
	"clock630":                        []rune{0x1F561},
	"clock7":                          []rune{0x1F556},
	"clock730":                        []rune{0x1F562},
	"clock8":                          []rune{0x1F557},
	"clock830":                        []rune{0x1F563},
	"clock9":                          []rune{0x1F558},
	"clock930":                        []rune{0x1F564},
	"closed_book":                     []rune{0x1F4D5},
	"closed_lock_with_key":            []rune{0x1F510},
	"closed_umbrella":                 []rune{0x1F302},
	"cloud":                           []rune{0x2601},
	"clubs":                           []rune{0x2663},
	"cn":                              []rune{0x1F1E8, 0x1F1F3},
	"cocktail":                        []rune{0x1F378},
	"coffee":                          []rune{0x2615},
	"cold_sweat":                      []rune{0x1F630},
	"collision":                       []rune{0x1F4A5},
	"computer":                        []rune{0x1F4BB},
	"confetti_ball":                   []rune{0x1F38A},
	"confounded":                      []rune{0x1F616},
	"confused":                        []rune{0x1F615},
	"congratulations":                 []rune{0x3297, 0xFE0F},
	"construction":                    []rune{0x1F6A7},
	"construction_worker":             []rune{0x1F477},
	"convenience_store":               []rune{0x1F3EA},
	"cookie":                          []rune{0x1F36A},
	"cool":                            []rune{0x1F192},
	"cop":                             []rune{0x1F46E},
	"copyright":                       []rune{0xA9},
	"corn":                            []rune{0x1F33D},
	"couple":                          []rune{0x1F46B},
	"couple_with_heart":               []rune{0x1F491},
	"couplekiss":                      []rune{0x1F48F},
	"cow":                             []rune{0x1F42E},
	"cow2":                            []rune{0x1F404},
	"credit_card":                     []rune{0x1F4B3},
	"crescent_moon":                   []rune{0x1F319},
	"crocodile":                       []rune{0x1F40A},
	"crossed_flags":                   []rune{0x1F38C},
	"crown":                           []rune{0x1F451},
	"cry":                             []rune{0x1F622},
	"crying_cat_face":                 []rune{0x1F63F},
	"crystal_ball":                    []rune{0x1F52E},
	"cupid":                           []rune{0x1F498},
	"curly_loop":                      []rune{0x27B0},
	"currency_exchange":               []rune{0x1F4B1},
	"curry":                           []rune{0x1F35B},
	"custard":                         []rune{0x1F36E},
	"customs":                         []rune{0x1F6C3},
	"cyclone":                         []rune{0x1F300},
	"dancer":                          []rune{0x1F483},
	"dancers":                         []rune{0x1F46F},
	"dango":                           []rune{0x1F361},
	"dart":                            []rune{0x1F3AF},
	"dash":                            []rune{0x1F4A8},
	"date":                            []rune{0x1F4C5},
	"de":                              []rune{0x1F1E9, 0x1F1EA},
	"deciduous_tree":                  []rune{0x1F333},
	"department_store":                []rune{0x1F3EC},
	"diamond_shape_with_a_dot_inside": []rune{0x1F4A0},
	"diamonds":                        []rune{0x2666, 0xFE0F},
	"disappointed":                    []rune{0x1F61E},
	"disappointed_relieved":           []rune{0x1F625},
	"dizzy":                           []rune{0x1F4AB},
	"dizzy_face":                      []rune{0x1F635},
	"do_not_litter":                   []rune{0x1F6AF},
	"dog":                             []rune{0x1F436},
	"dog2":                            []rune{0x1F415},
	"dollar":                          []rune{0x1F4B5},
	"dolls":                           []rune{0x1F38E},
	"dolphin":                         []rune{0x1F42C},
	"door":                            []rune{0x1F6AA},
	"doughnut":                        []rune{0x1F369},
	"dragon":                          []rune{0x1F409},
	"dragon_face":                     []rune{0x1F432},
	"dress":                           []rune{0x1F457},
	"dromedary_camel":                 []rune{0x1F42A},
	"droplet":                         []rune{0x1F4A7},
	"dvd":                             []rune{0x1F4C0},
	"e-mail":                          []rune{0x1F4E7},
	"ear":                             []rune{0x1F442},
	"ear_of_rice":                     []rune{0x1F33E},
	"earth_africa":                    []rune{0x1F30D},
	"earth_americas":                  []rune{0x1F30E},
	"earth_asia":                      []rune{0x1F30F},
	"egg":                             []rune{0x1F373},
	"eggplant":                        []rune{0x1F346},
	"eight":                           []rune{0x38, 0xFE0F, 0x20E3},
	"eight_pointed_black_star":        []rune{0x2734, 0xFE0F},
	"eight_spoked_asterisk":           []rune{0x2733, 0xFE0F},
	"electric_plug":                   []rune{0x1F50C},
	"elephant":                        []rune{0x1F418},
	"email":                           []rune{0x2709, 0xFE0F},
	"end":                             []rune{0x1F51A},
	"envelope":                        []rune{0x2709, 0xFE0F},
	"envelope_with_arrow":             []rune{0x1F4E9},
	"es":                              []rune{0x1F1EA, 0x1F1F8},
	"euro":                            []rune{0x1F4B6},
	"european_castle":                 []rune{0x1F3F0},
	"european_post_office":            []rune{0x1F3E4},
	"evergreen_tree":                  []rune{0x1F332},
	"exclamation":                     []rune{0x2757, 0xFE0F},
	"expressionless":                  []rune{0x1F611},
	"eyeglasses":                      []rune{0x1F453},
	"eyes":                            []rune{0x1F440},
	"facepunch":                       []rune{0x1F44A},
	"factory":                         []rune{0x1F3ED},
	"fallen_leaf":                     []rune{0x1F342},
	"family":                          []rune{0x1F46A},
	"fast_forward":                    []rune{0x23E9},
	"fax":                             []rune{0x1F4E0},
	"fearful":                         []rune{0x1F628},
	"feet":                            []rune{0x1F43E},
	"ferris_wheel":                    []rune{0x1F3A1},
	"file_folder":                     []rune{0x1F4C1},
	"fire":                            []rune{0x1F525},
	"fire_engine":                     []rune{0x1F692},
	"fireworks":                       []rune{0x1F386},
	"first_quarter_moon":              []rune{0x1F313},
	"first_quarter_moon_with_face":    []rune{0x1F31B},
	"fish":                            []rune{0x1F41F},
	"fish_cake":                       []rune{0x1F365},
	"fishing_pole_and_fish":           []rune{0x1F3A3},
	"fist":                            []rune{0x270A},
	"five":                            []rune{0x35, 0xFE0F, 0x20E3},
	"flags":                           []rune{0x1F38F},
	"flashlight":                      []rune{0x1F526},
	"flipper":                         []rune{0x1F42C},
	"floppy_disk":                     []rune{0x1F4BE},
	"flower_playing_cards":            []rune{0x1F3B4},
	"flushed":                         []rune{0x1F633},
	"foggy":                           []rune{0x1F301},
	"football":                        []rune{0x1F3C8},
	"footprints":                      []rune{0x1F463},
	"fork_and_knife":                  []rune{0x1F374},
	"fountain":                        []rune{0x26F2, 0xFE0F},
	"four":                            []rune{0x34, 0xFE0F, 0x20E3},
	"four_leaf_clover":                []rune{0x1F340},
	"fr":                              []rune{0x1F1EB, 0x1F1F7},
	"free":                            []rune{0x1F193},
	"fried_shrimp":                    []rune{0x1F364},
	"fries":                           []rune{0x1F35F},
	"frog":                            []rune{0x1F438},
	"frowning":                        []rune{0x1F626},
	"fuelpump":                        []rune{0x26FD, 0xFE0F},
	"full_moon":                       []rune{0x1F315},
	"full_moon_with_face":             []rune{0x1F31D},
	"game_die":                        []rune{0x1F3B2},
	"gb":                              []rune{0x1F1EC, 0x1F1E7},
	"gem":                             []rune{0x1F48E},
	"gemini":                          []rune{0x264A, 0xFE0F},
	"ghost":                           []rune{0x1F47B},
	"gift":                            []rune{0x1F381},
	"gift_heart":                      []rune{0x1F49D},
	"girl":                            []rune{0x1F467},
	"globe_with_meridians":            []rune{0x1F310},
	"goat":                            []rune{0x1F410},
	"golf":                            []rune{0x26F3, 0xFE0F},
	"grapes":                          []rune{0x1F347},
	"green_apple":                     []rune{0x1F34F},
	"green_book":                      []rune{0x1F4D7},
	"green_heart":                     []rune{0x1F49A},
	"grey_exclamation":                []rune{0x2755},
	"grey_question":                   []rune{0x2754},
	"grimacing":                       []rune{0x1F62C},
	"grin":                            []rune{0x1F601},
	"grinning":                        []rune{0x1F600},
	"guardsman":                       []rune{0x1F482},
	"guitar":                          []rune{0x1F3B8},
	"gun":                             []rune{0x1F52B},
	"haircut":                         []rune{0x1F487},
	"hamburger":                       []rune{0x1F354},
	"hammer":                          []rune{0x1F528},
	"hamster":                         []rune{0x1F439},
	"hand":                            []rune{0x270B},
	"handbag":                         []rune{0x1F45C},
	"hankey":                          []rune{0x1F4A9},
	"hash":                            []rune{0x23, 0xFE0F, 0x20E3},
	"hatched_chick":                   []rune{0x1F425},
	"hatching_chick":                  []rune{0x1F423},
	"headphones":                      []rune{0x1F3A7},
	"hear_no_evil":                    []rune{0x1F649},
	"heart":                           []rune{0x2764, 0xFE0F},
	"heart_decoration":                []rune{0x1F49F},
	"heart_eyes":                      []rune{0x1F60D},
	"heart_eyes_cat":                  []rune{0x1F63B},
	"heartbeat":                       []rune{0x1F493},
	"heartpulse":                      []rune{0x1F497},
	"hearts":                          []rune{0x2665, 0xFE0F},
	"heavy_check_mark":                []rune{0x2714, 0xFE0F},
	"heavy_division_sign":             []rune{0x2797},
	"heavy_dollar_sign":               []rune{0x1F4B2},
	"heavy_exclamation_mark":          []rune{0x2757, 0xFE0F},
	"heavy_minus_sign":                []rune{0x2796},
	"heavy_multiplication_x":          []rune{0x2716, 0xFE0F},
	"heavy_plus_sign":                 []rune{0x2795},
	"helicopter":                      []rune{0x1F681},
	"herb":                            []rune{0x1F33F},
	"hibiscus":                        []rune{0x1F33A},
	"high_brightness":                 []rune{0x1F506},
	"high_heel":                       []rune{0x1F460},
	"hocho":                           []rune{0x1F52A},
	"honey_pot":                       []rune{0x1F36F},
	"honeybee":                        []rune{0x1F41D},
	"horse":                           []rune{0x1F434},
	"horse_racing":                    []rune{0x1F3C7},
	"hospital":                        []rune{0x1F3E5},
	"hotel":                           []rune{0x1F3E8},
	"hotsprings":                      []rune{0x2668, 0xFE0F},
	"hourglass":                       []rune{0x231B, 0xFE0F},
	"hourglass_flowing_sand":          []rune{0x23F3},
	"house":                           []rune{0x1F3E0},
	"house_with_garden":               []rune{0x1F3E1},
	"hushed":                          []rune{0x1F62F},
	"ice_cream":                       []rune{0x1F368},
	"icecream":                        []rune{0x1F366},
	"id":                              []rune{0x1F194},
	"ideograph_advantage":             []rune{0x1F250},
	"imp":                             []rune{0x1F47F},
	"inbox_tray":                      []rune{0x1F4E5},
	"incoming_envelope":               []rune{0x1F4E8},
	"information_desk_person":         []rune{0x1F481},
	"information_source":              []rune{0x2139, 0xFE0F},
	"innocent":                        []rune{0x1F607},
	"interrobang":                     []rune{0x2049, 0xFE0F},
	"iphone":                          []rune{0x1F4F1},
	"it":                              []rune{0x1F1EE, 0x1F1F9},
	"izakaya_lantern":                 []rune{0x1F3EE},
	"jack_o_lantern":                  []rune{0x1F383},
	"japan":                           []rune{0x1F5FE},
	"japanese_castle":                 []rune{0x1F3EF},
	"japanese_goblin":                 []rune{0x1F47A},
	"japanese_ogre":                   []rune{0x1F479},
	"jeans":                           []rune{0x1F456},
	"joy":                             []rune{0x1F602},
	"joy_cat":                         []rune{0x1F639},
	"jp":                              []rune{0x1F1EF, 0x1F1F5},
	"key":                             []rune{0x1F511},
	"keycap_ten":                      []rune{0x1F51F},
	"kimono":                          []rune{0x1F458},
	"kiss":                            []rune{0x1F48B},
	"kissing":                         []rune{0x1F617},
	"kissing_cat":                     []rune{0x1F63D},
	"kissing_closed_eyes":             []rune{0x1F61A},
	"kissing_heart":                   []rune{0x1F618},
	"kissing_smiling_eyes":            []rune{0x1F619},
	"knife":                           []rune{0x1F52A},
	"koala":                           []rune{0x1F428},
	"koko":                            []rune{0x1F201},
	"kr":                              []rune{0x1F1F0, 0x1F1F7},
	"lantern":                         []rune{0x1F3EE},
	"large_blue_circle":               []rune{0x1F535},
	"large_blue_diamond":              []rune{0x1F537},
	"large_orange_diamond":            []rune{0x1F536},
	"last_quarter_moon":               []rune{0x1F317},
	"last_quarter_moon_with_face":     []rune{0x1F31C},
	"laughing":                        []rune{0x1F606},
	"leaves":                          []rune{0x1F343},
	"ledger":                          []rune{0x1F4D2},
	"left_luggage":                    []rune{0x1F6C5},
	"left_right_arrow":                []rune{0x2194, 0xFE0F},
	"leftwards_arrow_with_hook":       []rune{0x21A9, 0xFE0F},
	"lemon":                           []rune{0x1F34B},
	"leo":                             []rune{0x264C, 0xFE0F},
	"leopard":                         []rune{0x1F406},
	"libra":                           []rune{0x264E, 0xFE0F},
	"light_rail":                      []rune{0x1F688},
	"link":                            []rune{0x1F517},
	"lips":                            []rune{0x1F444},
	"lipstick":                        []rune{0x1F484},
	"lock":                            []rune{0x1F512},
	"lock_with_ink_pen":               []rune{0x1F50F},
	"lollipop":                        []rune{0x1F36D},
	"loop":                            []rune{0x27BF},
	"loud_sound":                      []rune{0x1F50A},
	"loudspeaker":                     []rune{0x1F4E2},
	"love_hotel":                      []rune{0x1F3E9},
	"love_letter":                     []rune{0x1F48C},
	"low_brightness":                  []rune{0x1F505},
	"m":                               []rune{0x24C2, 0xFE0F},
	"mag":                             []rune{0x1F50D},
	"mag_right":                       []rune{0x1F50E},
	"mahjong":                         []rune{0x1F004, 0xFE0F},
	"mailbox":                         []rune{0x1F4EB},
	"mailbox_closed":                  []rune{0x1F4EA},
	"mailbox_with_mail":               []rune{0x1F4EC},
	"mailbox_with_no_mail":            []rune{0x1F4ED},
	"man":                             []rune{0x1F468},
	"man_with_gua_pi_mao":             []rune{0x1F472},
	"man_with_turban":                 []rune{0x1F473},
	"mans_shoe":                       []rune{0x1F45E},
	"maple_leaf":                      []rune{0x1F341},
	"mask":                            []rune{0x1F637},
	"massage":                         []rune{0x1F486},
	"meat_on_bone":                    []rune{0x1F356},
	"mega":                            []rune{0x1F4E3},
	"melon":                           []rune{0x1F348},
	"memo":                            []rune{0x1F4DD},
	"mens":                            []rune{0x1F6B9},
	"metro":                           []rune{0x1F687},
	"microphone":                      []rune{0x1F3A4},
	"microscope":                      []rune{0x1F52C},
	"milky_way":                       []rune{0x1F30C},
	"minibus":                         []rune{0x1F690},
	"minidisc":                        []rune{0x1F4BD},
	"mobile_phone_off":                []rune{0x1F4F4},
	"money_with_wings":                []rune{0x1F4B8},
	"moneybag":                        []rune{0x1F4B0},
	"monkey":                          []rune{0x1F412},
	"monkey_face":                     []rune{0x1F435},
	"monorail":                        []rune{0x1F69D},
	"moon":                            []rune{0x1F314},
	"mortar_board":                    []rune{0x1F393},
	"mount_fuji":                      []rune{0x1F5FB},
	"mountain_bicyclist":              []rune{0x1F6B5},
	"mountain_cableway":               []rune{0x1F6A0},
	"mountain_railway":                []rune{0x1F69E},
	"mouse":                           []rune{0x1F42D},
	"mouse2":                          []rune{0x1F401},
	"movie_camera":                    []rune{0x1F3A5},
	"moyai":                           []rune{0x1F5FF},
	"muscle":                          []rune{0x1F4AA},
	"mushroom":                        []rune{0x1F344},
	"musical_keyboard":                []rune{0x1F3B9},
	"musical_note":                    []rune{0x1F3B5},
	"musical_score":                   []rune{0x1F3BC},
	"mute":                            []rune{0x1F507},
	"nail_care":                       []rune{0x1F485},
	"name_badge":                      []rune{0x1F4DB},
	"necktie":                         []rune{0x1F454},
	"negative_squared_cross_mark":     []rune{0x274E},
	"neutral_face":                    []rune{0x1F610},
	"new":                             []rune{0x1F195},
	"new_moon":                        []rune{0x1F311},
	"new_moon_with_face":              []rune{0x1F31A},
	"newspaper":                       []rune{0x1F4F0},
	"ng":                              []rune{0x1F196},
	"night_with_stars":                []rune{0x1F303},
	"nine":                            []rune{0x39, 0xFE0F, 0x20E3},
	"no_bell":                         []rune{0x1F515},
	"no_bicycles":                     []rune{0x1F6B3},
	"no_entry":                        []rune{0x26D4, 0xFE0F},
	"no_entry_sign":                   []rune{0x1F6AB},
	"no_good":                         []rune{0x1F645},
	"no_mobile_phones":                []rune{0x1F4F5},
	"no_mouth":                        []rune{0x1F636},
	"no_pedestrians":                  []rune{0x1F6B7},
	"no_smoking":                      []rune{0x1F6AD},
	"non-potable_water":               []rune{0x1F6B1},
	"nose":                            []rune{0x1F443},
	"notebook":                        []rune{0x1F4D3},
	"notebook_with_decorative_cover":  []rune{0x1F4D4},
	"notes":                           []rune{0x1F3B6},
	"nut_and_bolt":                    []rune{0x1F529},
	"o":                               []rune{0x2B55, 0xFE0F},
	"o2":                              []rune{0x1F17E},
	"ocean":                           []rune{0x1F30A},
	"octopus":                         []rune{0x1F419},
	"oden":                            []rune{0x1F362},
	"office":                          []rune{0x1F3E2},
	"ok":                              []rune{0x1F197},
	"ok_hand":                         []rune{0x1F44C},
	"ok_woman":                        []rune{0x1F646},
	"older_man":                       []rune{0x1F474},
	"older_woman":                     []rune{0x1F475},
	"on":                              []rune{0x1F51B},
	"oncoming_automobile":             []rune{0x1F698},
	"oncoming_bus":                    []rune{0x1F68D},
	"oncoming_police_car":             []rune{0x1F694},
	"oncoming_taxi":                   []rune{0x1F696},
	"one":                             []rune{0x31, 0xFE0F, 0x20E3},
	"open_book":                       []rune{0x1F4D6},
	"open_file_folder":                []rune{0x1F4C2},
	"open_hands":                      []rune{0x1F450},
	"open_mouth":                      []rune{0x1F62E},
	"ophiuchus":                       []rune{0x26CE},
	"orange_book":                     []rune{0x1F4D9},
	"outbox_tray":                     []rune{0x1F4E4},
	"ox":                              []rune{0x1F402},
	"package":                         []rune{0x1F4E6},
	"page_facing_up":                  []rune{0x1F4C4},
	"page_with_curl":                  []rune{0x1F4C3},
	"pager":                           []rune{0x1F4DF},
	"palm_tree":                       []rune{0x1F334},
	"panda_face":                      []rune{0x1F43C},
	"paperclip":                       []rune{0x1F4CE},
	"parking":                         []rune{0x1F17F, 0xFE0F},
	"part_alternation_mark":           []rune{0x303D, 0xFE0F},
	"partly_sunny":                    []rune{0x26C5, 0xFE0F},
	"passport_control":                []rune{0x1F6C2},
	"paw_prints":                      []rune{0x1F43E},
	"peach":                           []rune{0x1F351},
	"pear":                            []rune{0x1F350},
	"pencil":                          []rune{0x1F4DD},
	"pencil2":                         []rune{0x270F, 0xFE0F},
	"penguin":                         []rune{0x1F427},
	"pensive":                         []rune{0x1F614},
	"performing_arts":                 []rune{0x1F3AD},
	"persevere":                       []rune{0x1F623},
	"person_frowning":                 []rune{0x1F64D},
	"person_with_blond_hair":          []rune{0x1F471},
	"person_with_pouting_face":        []rune{0x1F64E},
	"phone":                           []rune{0x260E, 0xFE0F},
	"pig":                             []rune{0x1F437},
	"pig2":                            []rune{0x1F416},
	"pig_nose":                        []rune{0x1F43D},
	"pill":                            []rune{0x1F48A},
	"pineapple":                       []rune{0x1F34D},
	"pisces":                          []rune{0x2653, 0xFE0F},
	"pizza":                           []rune{0x1F355},
	"point_down":                      []rune{0x1F447},
	"point_left":                      []rune{0x1F448},
	"point_right":                     []rune{0x1F449},
	"point_up":                        []rune{0x261D, 0xFE0F},
	"point_up_2":                      []rune{0x1F446},
	"police_car":                      []rune{0x1F693},
	"poodle":                          []rune{0x1F429},
	"poop":                            []rune{0x1F4A9},
	"post_office":                     []rune{0x1F3E3},
	"postal_horn":                     []rune{0x1F4EF},
	"postbox":                         []rune{0x1F4EE},
	"potable_water":                   []rune{0x1F6B0},
	"pouch":                           []rune{0x1F45D},
	"poultry_leg":                     []rune{0x1F357},
	"pound":                           []rune{0x1F4B7},
	"pouting_cat":                     []rune{0x1F63E},
	"pray":                            []rune{0x1F64F},
	"princess":                        []rune{0x1F478},
	"punch":                           []rune{0x1F44A},
	"purple_heart":                    []rune{0x1F49C},
	"purse":                           []rune{0x1F45B},
	"pushpin":                         []rune{0x1F4CC},
	"put_litter_in_its_place":         []rune{0x1F6AE},
	"question":                        []rune{0x2753},
	"rabbit":                          []rune{0x1F430},
	"rabbit2":                         []rune{0x1F407},
	"racehorse":                       []rune{0x1F40E},
	"radio":                           []rune{0x1F4FB},
	"radio_button":                    []rune{0x1F518},
	"rage":                            []rune{0x1F621},
	"railway_car":                     []rune{0x1F683},
	"rainbow":                         []rune{0x1F308},
	"raised_hand":                     []rune{0x270B},
	"raised_hands":                    []rune{0x1F64C},
	"raising_hand":                    []rune{0x1F64B},
	"ram":                             []rune{0x1F40F},
	"ramen":                           []rune{0x1F35C},
	"rat":                             []rune{0x1F400},
	"recycle":                         []rune{0x267B, 0xFE0F},
	"red_car":                         []rune{0x1F697},
	"red_circle":                      []rune{0x1F534},
	"registered":                      []rune{0xAE},
	"relaxed":                         []rune{0x263A, 0xFE0F},
	"relieved":                        []rune{0x1F60C},
	"repeat":                          []rune{0x1F501},
	"repeat_one":                      []rune{0x1F502},
	"restroom":                        []rune{0x1F6BB},
	"revolving_hearts":                []rune{0x1F49E},
	"rewind":                          []rune{0x23EA},
	"ribbon":                          []rune{0x1F380},
	"rice":                            []rune{0x1F35A},
	"rice_ball":                       []rune{0x1F359},
	"rice_cracker":                    []rune{0x1F358},
	"rice_scene":                      []rune{0x1F391},
	"ring":                            []rune{0x1F48D},
	"rocket":                          []rune{0x1F680},
	"roller_coaster":                  []rune{0x1F3A2},
	"rooster":                         []rune{0x1F413},
	"rose":                            []rune{0x1F339},
	"rotating_light":                  []rune{0x1F6A8},
	"round_pushpin":                   []rune{0x1F4CD},
	"rowboat":                         []rune{0x1F6A3},
	"ru":                              []rune{0x1F1F7, 0x1F1FA},
	"rugby_football":                  []rune{0x1F3C9},
	"runner":                          []rune{0x1F3C3},
	"running":                         []rune{0x1F3C3},
	"running_shirt_with_sash":         []rune{0x1F3BD},
	"sa":                              []rune{0x1F202},
	"sagittarius":                     []rune{0x2650, 0xFE0F},
	"sailboat":                        []rune{0x26F5, 0xFE0F},
	"sake":                            []rune{0x1F376},
	"sandal":                          []rune{0x1F461},
	"santa":                           []rune{0x1F385},
	"satellite":                       []rune{0x1F4E1},
	"satisfied":                       []rune{0x1F606},
	"saxophone":                       []rune{0x1F3B7},
	"school":                          []rune{0x1F3EB},
	"school_satchel":                  []rune{0x1F392},
	"scissors":                        []rune{0x2702, 0xFE0F},
	"scorpius":                        []rune{0x264F, 0xFE0F},
	"scream":                          []rune{0x1F631},
	"scream_cat":                      []rune{0x1F640},
	"scroll":                          []rune{0x1F4DC},
	"seat":                            []rune{0x1F4BA},
	"secret":                          []rune{0x3299, 0xFE0F},
	"see_no_evil":                     []rune{0x1F648},
	"seedling":                        []rune{0x1F331},
	"seven":                           []rune{0x37, 0xFE0F, 0x20E3},
	"shaved_ice":                      []rune{0x1F367},
	"sheep":                           []rune{0x1F411},
	"shell":                           []rune{0x1F41A},
	"ship":                            []rune{0x1F6A2},
	"shirt":                           []rune{0x1F455},
	"shit":                            []rune{0x1F4A9},
	"shoe":                            []rune{0x1F45E},
	"shower":                          []rune{0x1F6BF},
	"signal_strength":                 []rune{0x1F4F6},
	"six":                             []rune{0x36, 0xFE0F, 0x20E3},
	"six_pointed_star":                []rune{0x1F52F},
	"ski":                             []rune{0x1F3BF},
	"skull":                           []rune{0x1F480},
	"sleeping":                        []rune{0x1F634},
	"sleepy":                          []rune{0x1F62A},
	"slot_machine":                    []rune{0x1F3B0},
	"small_blue_diamond":              []rune{0x1F539},
	"small_orange_diamond":            []rune{0x1F538},
	"small_red_triangle":              []rune{0x1F53A},
	"small_red_triangle_down":         []rune{0x1F53B},
	"smile":                           []rune{0x1F604},
	"smile_cat":                       []rune{0x1F638},
	"smiley":                          []rune{0x1F603},
	"smiley_cat":                      []rune{0x1F63A},
	"smiling_imp":                     []rune{0x1F608},
	"smirk":                           []rune{0x1F60F},
	"smirk_cat":                       []rune{0x1F63C},
	"smoking":                         []rune{0x1F6AC},
	"snail":                           []rune{0x1F40C},
	"snake":                           []rune{0x1F40D},
	"snowboarder":                     []rune{0x1F3C2},
	"snowflake":                       []rune{0x2744, 0xFE0F},
	"snowman":                         []rune{0x26C4, 0xFE0F},
	"sob":                             []rune{0x1F62D},
	"soccer":                          []rune{0x26BD, 0xFE0F},
	"soon":                            []rune{0x1F51C},
	"sos":                             []rune{0x1F198},
	"sound":                           []rune{0x1F509},
	"space_invader":                   []rune{0x1F47E},
	"spades":                          []rune{0x2660, 0xFE0F},
	"spaghetti":                       []rune{0x1F35D},
	"sparkle":                         []rune{0x2747, 0xFE0F},
	"sparkler":                        []rune{0x1F387},
	"sparkles":                        []rune{0x2728},
	"sparkling_heart":                 []rune{0x1F496},
	"speak_no_evil":                   []rune{0x1F64A},
	"speaker":                         []rune{0x1F508},
	"speech_balloon":                  []rune{0x1F4AC},
	"speedboat":                       []rune{0x1F6A4},
	"star":                            []rune{0x2B50, 0xFE0F},
	"star2":                           []rune{0x1F31F},
	"stars":                           []rune{0x1F320},
	"station":                         []rune{0x1F689},
	"statue_of_liberty":               []rune{0x1F5FD},
	"steam_locomotive":                []rune{0x1F682},
	"stew":                            []rune{0x1F372},
	"straight_ruler":                  []rune{0x1F4CF},
	"strawberry":                      []rune{0x1F353},
	"stuck_out_tongue":                []rune{0x1F61B},
	"stuck_out_tongue_closed_eyes":    []rune{0x1F61D},
	"stuck_out_tongue_winking_eye":    []rune{0x1F61C},
	"sun_with_face":                   []rune{0x1F31E},
	"sunflower":                       []rune{0x1F33B},
	"sunglasses":                      []rune{0x1F60E},
	"sunny":                           []rune{0x2600, 0xFE0F},
	"sunrise":                         []rune{0x1F305},
	"sunrise_over_mountains":          []rune{0x1F304},
	"surfer":                          []rune{0x1F3C4},
	"sushi":                           []rune{0x1F363},
	"suspension_railway":              []rune{0x1F69F},
	"sweat":                           []rune{0x1F613},
	"sweat_drops":                     []rune{0x1F4A6},
	"sweat_smile":                     []rune{0x1F605},
	"sweet_potato":                    []rune{0x1F360},
	"swimmer":                         []rune{0x1F3CA},
	"symbols":                         []rune{0x1F523},
	"syringe":                         []rune{0x1F489},
	"tada":                            []rune{0x1F389},
	"tanabata_tree":                   []rune{0x1F38B},
	"tangerine":                       []rune{0x1F34A},
	"taurus":                          []rune{0x2649, 0xFE0F},
	"taxi":                            []rune{0x1F695},
	"tea":                             []rune{0x1F375},
	"telephone":                       []rune{0x260E, 0xFE0F},
	"telephone_receiver":              []rune{0x1F4DE},
	"telescope":                       []rune{0x1F52D},
	"tennis":                          []rune{0x1F3BE},
	"tent":                            []rune{0x26FA, 0xFE0F},
	"thought_balloon":                 []rune{0x1F4AD},
	"three":                           []rune{0x33, 0xFE0F, 0x20E3},
	"thumbsdown":                      []rune{0x1F44E},
	"thumbsup":                        []rune{0x1F44D},
	"ticket":                          []rune{0x1F3AB},
	"tiger":                           []rune{0x1F42F},
	"tiger2":                          []rune{0x1F405},
	"tired_face":                      []rune{0x1F62B},
	"tm":                              []rune{0x2122},
	"toilet":                          []rune{0x1F6BD},
	"tokyo_tower":                     []rune{0x1F5FC},
	"tomato":                          []rune{0x1F345},
	"tongue":                          []rune{0x1F445},
	"top":                             []rune{0x1F51D},
	"tophat":                          []rune{0x1F3A9},
	"tractor":                         []rune{0x1F69C},
	"traffic_light":                   []rune{0x1F6A5},
	"train":                           []rune{0x1F68B},
	"train2":                          []rune{0x1F686},
	"tram":                            []rune{0x1F68A},
	"triangular_flag_on_post":         []rune{0x1F6A9},
	"triangular_ruler":                []rune{0x1F4D0},
	"trident":                         []rune{0x1F531},
	"triumph":                         []rune{0x1F624},
	"trolleybus":                      []rune{0x1F68E},
	"trophy":                          []rune{0x1F3C6},
	"tropical_drink":                  []rune{0x1F379},
	"tropical_fish":                   []rune{0x1F420},
	"truck":                           []rune{0x1F69A},
	"trumpet":                         []rune{0x1F3BA},
	"tshirt":                          []rune{0x1F455},
	"tulip":                           []rune{0x1F337},
	"turtle":                          []rune{0x1F422},
	"tv":                              []rune{0x1F4FA},
	"twisted_rightwards_arrows":       []rune{0x1F500},
	"two":                             []rune{0x32, 0xFE0F, 0x20E3},
	"two_hearts":                      []rune{0x1F495},
	"two_men_holding_hands":           []rune{0x1F46C},
	"two_women_holding_hands":         []rune{0x1F46D},
	"u5272":                           []rune{0x1F239},
	"u5408":                           []rune{0x1F234},
	"u55b6":                           []rune{0x1F23A},
	"u6307":                           []rune{0x1F22F, 0xFE0F},
	"u6708":                           []rune{0x1F237},
	"u6709":                           []rune{0x1F236},
	"u6e80":                           []rune{0x1F235},
	"u7121":                           []rune{0x1F21A, 0xFE0F},
	"u7533":                           []rune{0x1F238},
	"u7981":                           []rune{0x1F232},
	"u7a7a":                           []rune{0x1F233},
	"uk":                              []rune{0x1F1EC, 0x1F1E7},
	"umbrella":                        []rune{0x2614, 0xFE0F},
	"unamused":                        []rune{0x1F612},
	"underage":                        []rune{0x1F51E},
	"unlock":                          []rune{0x1F513},
	"up":                              []rune{0x1F199},
	"us":                              []rune{0x1F1FA, 0x1F1F8},
	"v":                               []rune{0x270C, 0xFE0F},
	"vertical_traffic_light":          []rune{0x1F6A6},
	"vhs":                             []rune{0x1F4FC},
	"vibration_mode":                  []rune{0x1F4F3},
	"video_camera":                    []rune{0x1F4F9},
	"video_game":                      []rune{0x1F3AE},
	"violin":                          []rune{0x1F3BB},
	"virgo":                           []rune{0x264D, 0xFE0F},
	"volcano":                         []rune{0x1F30B},
	"vs":                              []rune{0x1F19A},
	"walking":                         []rune{0x1F6B6},
	"waning_crescent_moon":            []rune{0x1F318},
	"waning_gibbous_moon":             []rune{0x1F316},
	"warning":                         []rune{0x26A0, 0xFE0F},
	"watch":                           []rune{0x231A, 0xFE0F},
	"water_buffalo":                   []rune{0x1F403},
	"watermelon":                      []rune{0x1F349},
	"wave":                            []rune{0x1F44B},
	"wavy_dash":                       []rune{0x3030},
	"waxing_crescent_moon":            []rune{0x1F312},
	"waxing_gibbous_moon":             []rune{0x1F314},
	"wc":                              []rune{0x1F6BE},
	"weary":                           []rune{0x1F629},
	"wedding":                         []rune{0x1F492},
	"whale":                           []rune{0x1F433},
	"whale2":                          []rune{0x1F40B},
	"wheelchair":                      []rune{0x267F, 0xFE0F},
	"white_check_mark":                []rune{0x2705},
	"white_circle":                    []rune{0x26AA, 0xFE0F},
	"white_flower":                    []rune{0x1F4AE},
	"white_large_square":              []rune{0x2B1C, 0xFE0F},
	"white_medium_small_square":       []rune{0x25FD, 0xFE0F},
	"white_medium_square":             []rune{0x25FB, 0xFE0F},
	"white_small_square":              []rune{0x25AB, 0xFE0F},
	"white_square_button":             []rune{0x1F533},
	"wind_chime":                      []rune{0x1F390},
	"wine_glass":                      []rune{0x1F377},
	"wink":                            []rune{0x1F609},
	"wolf":                            []rune{0x1F43A},
	"woman":                           []rune{0x1F469},
	"womans_clothes":                  []rune{0x1F45A},
	"womans_hat":                      []rune{0x1F452},
	"womens":                          []rune{0x1F6BA},
	"worried":                         []rune{0x1F61F},
	"wrench":                          []rune{0x1F527},
	"x":                               []rune{0x274C},
	"yellow_heart":                    []rune{0x1F49B},
	"yen":                             []rune{0x1F4B4},
	"yum":                             []rune{0x1F60B},
	"zap":                             []rune{0x26A1, 0xFE0F},
	"zero":                            []rune{0x30, 0xFE0F, 0x20E3},
	"zzz":                             []rune{0x1F4A4},
}

// Emojize converts emoji names (e.g., :pizza:) to emoji characters.
func Emojize(s string) string {
	for name, emoji := range name2codes {
		marker := ":" + name + ":"
		s = strings.ReplaceAll(s, marker, string(emoji))
	}
	return s
}
